<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_StockReposicionDetalleLog.xml */
/* Generado: 2020-08-18 04:21:28 */

/* Mantenimiento de los registros de la tabla MST_StockReposicionDetalleLog */
abstract class BaseMST_StockReposicionDetalleLogDP extends MST_StockReposicionDetalleLogBV
{
    /* Constructor ( Establece los valores desde un objeto MST_StockReposicionDetalleLogBN ) */
    public function __construct( MST_StockReposicionDetalleLogBN $o_MST_StockReposicionDetalleLogBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN ) )
        {
            $this->setByBN( $o_MST_StockReposicionDetalleLogBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_StockReposicionDetalleLogBN */
    public function setByBN( MST_StockReposicionDetalleLogBN $o_MST_StockReposicionDetalleLogBN )
    {
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getIdSRDLog() ) )
        {
            $this->setIdSRDLog( $o_MST_StockReposicionDetalleLogBN->getIdSRDLog() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MST_StockReposicionDetalleLogBN->getIdCompania() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_MST_StockReposicionDetalleLogBN->getIdSucursal() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_MST_StockReposicionDetalleLogBN->getIdAlmacen() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_MST_StockReposicionDetalleLogBN->getIdPersona() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getIdItem() ) )
        {
            $this->setIdItem( $o_MST_StockReposicionDetalleLogBN->getIdItem() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_StockReposicionDetalleLogBN->getEstado() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getStockMinimo() ) )
        {
            $this->setStockMinimo( $o_MST_StockReposicionDetalleLogBN->getStockMinimo() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getStockMaximo() ) )
        {
            $this->setStockMaximo( $o_MST_StockReposicionDetalleLogBN->getStockMaximo() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getStockActual() ) )
        {
            $this->setStockActual( $o_MST_StockReposicionDetalleLogBN->getStockActual() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_StockReposicionDetalleLogBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_StockReposicionDetalleLogBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_StockReposicionDetalleLogBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getUsuarioModificcion() ) )
        {
            $this->setUsuarioModificcion( $o_MST_StockReposicionDetalleLogBN->getUsuarioModificcion() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getFechaLog() ) )
        {
            $this->setFechaLog( $o_MST_StockReposicionDetalleLogBN->getFechaLog() );
        }
        if ( !is_null( $o_MST_StockReposicionDetalleLogBN->getUsuarioLog() ) )
        {
            $this->setUsuarioLog( $o_MST_StockReposicionDetalleLogBN->getUsuarioLog() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_StockReposicionDetalleLogFN = new MST_StockReposicionDetalleLogFN();
        $o_MST_StockReposicionDetalleLogBN = $o_MST_StockReposicionDetalleLogFN->selectByPk( $this->getIdSRDLog() );
        if ( is_null( $o_MST_StockReposicionDetalleLogBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_StockReposicionDetalleLog ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdSRDLog() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSRDLog";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSRDLog()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPersona";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMinimo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockMinimo";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockMinimo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMaximo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockMaximo";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockMaximo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockActual() ) )
            {
                $s_SQLQuery1 .= $s_Separator."StockActual";
                $s_SQLQuery2 .= $s_Separator."".$this->getStockActual()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaLog() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaLog";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaLog()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioLog() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioLog";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioLog()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_StockReposicionDetalleLog SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery .= $s_Separator."IdAlmacen = '".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery .= $s_Separator."IdPersona = ".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMinimo() ) )
            {
                $s_SQLQuery .= $s_Separator."StockMinimo = ".$this->getStockMinimo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockMaximo() ) )
            {
                $s_SQLQuery .= $s_Separator."StockMaximo = ".$this->getStockMaximo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getStockActual() ) )
            {
                $s_SQLQuery .= $s_Separator."StockActual = ".$this->getStockActual()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificcion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificcion = '".$this->getUsuarioModificcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaLog() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaLog = '".$this->getFechaLog()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioLog() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioLog = '".$this->getUsuarioLog()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdSRDLog = ".$this->getIdSRDLog().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_StockReposicionDetalleLog WHERE  IdSRDLog = ".$this->getIdSRDLog().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>